Index: /trunk/geant4/interfaces/History
===================================================================
--- /trunk/geant4/interfaces/History	(revision 703)
+++ /trunk/geant4/interfaces/History	(revision 704)
@@ -1,3 +1,3 @@
-$Id: History,v 1.93 2008/01/15 11:04:26 lgarnier Exp $
+$Id: History,v 1.94 2008/01/30 11:16:17 lgarnier Exp $
 -------------------------------------------------------------------
 
@@ -18,5 +18,8 @@
      ----------------------------------------------------------
 
-15th Janvier 2007, Laurent Garnier
+30th January 2007, Laurent Garnier
+ - Add a search area in the help widget
+
+15th January 2007, Laurent Garnier
  - Fixed some layout problems
  - GNUmakefile : Added a macro for moc file
Index: /trunk/geant4/interfaces/basic/include/G4UIQt.hh
===================================================================
--- /trunk/geant4/interfaces/basic/include/G4UIQt.hh	(revision 703)
+++ /trunk/geant4/interfaces/basic/include/G4UIQt.hh	(revision 704)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4UIQt.hh,v 1.10 2008/01/15 11:04:26 lgarnier Exp $
+// $Id: G4UIQt.hh,v 1.11 2008/01/30 11:16:17 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
@@ -75,5 +75,4 @@
 //
 // Class description - end :
-
 
 class G4UIQt : public QObject, public G4VBasicShell, public G4VInteractiveSession {
Index: /trunk/geant4/interfaces/basic/src/G4UIQt.cc
===================================================================
--- /trunk/geant4/interfaces/basic/src/G4UIQt.cc	(revision 703)
+++ /trunk/geant4/interfaces/basic/src/G4UIQt.cc	(revision 704)
@@ -25,10 +25,10 @@
 //
 //
-// $Id: G4UIQt.cc,v 1.14 2008/01/15 11:04:26 lgarnier Exp $
+// $Id: G4UIQt.cc,v 1.15 2008/01/30 11:16:17 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
 // L. Garnier
 
-#define GEANT4_QT_DEBUG
+//#define GEANT4_QT_DEBUG
 
 #ifdef G4UI_BUILD_QT_SESSION
Index: /trunk/geant4/visualization/OpenGL/History
===================================================================
--- /trunk/geant4/visualization/OpenGL/History	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/History	(revision 704)
@@ -1,3 +1,3 @@
-$Id: History,v 1.106 2008/01/15 11:05:08 lgarnier Exp $
+$Id: History,v 1.108 2008/01/30 11:16:42 lgarnier Exp $
 -------------------------------------------------------------------
 
@@ -21,5 +21,11 @@
 -------------------------------------
 
-15th Janvier 2007, Laurent Garnier
+30th January 2007, Laurent Garnier
+ - Add moving camera on left/right/up/down arrown, going forward/backward
+   on SHIFT+up/down, zoom in with +/- keys
+ - Add a context menu entry for projection perspective/orthographic
+ - Fix some bugs on windows in export dialog
+
+15th January 2007, Laurent Garnier
  - Fixed some layout problems on export dialog box
  - Some improvements on exports formats
Index: /trunk/geant4/visualization/OpenGL/include/G4OpenGLQtExportDialog.hh
===================================================================
--- /trunk/geant4/visualization/OpenGL/include/G4OpenGLQtExportDialog.hh	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/include/G4OpenGLQtExportDialog.hh	(revision 704)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLQtExportDialog.hh,v 1.4 2008/01/15 11:05:08 lgarnier Exp $
+// $Id: G4OpenGLQtExportDialog.hh,v 1.5 2008/01/30 10:54:13 lgarnier Exp $
 // GEANT4 tag $Name: 
 //
Index: /trunk/geant4/visualization/OpenGL/include/G4OpenGLQtViewer.hh
===================================================================
--- /trunk/geant4/visualization/OpenGL/include/G4OpenGLQtViewer.hh	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/include/G4OpenGLQtViewer.hh	(revision 704)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLQtViewer.hh,v 1.6 2008/01/15 11:05:08 lgarnier Exp $
+// $Id: G4OpenGLQtViewer.hh,v 1.7 2008/01/30 10:54:13 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
@@ -157,5 +157,5 @@
   void toggleHaloing(bool);
   void toggleAux(bool);
-  void toggleFullScreen(bool);
+  void toggleFullScreen();
   // Only use for Qt>4.0
   void dialogClosed();
Index: /trunk/geant4/visualization/OpenGL/include/G4OpenGLSceneHandler.icc
===================================================================
--- /trunk/geant4/visualization/OpenGL/include/G4OpenGLSceneHandler.icc	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/include/G4OpenGLSceneHandler.icc	(revision 704)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLSceneHandler.icc,v 1.7 2006/06/29 21:17:58 gunter Exp $
-// GEANT4 tag $Name: geant4-09-00-ref-01 $
+// $Id: G4OpenGLSceneHandler.icc,v 1.8 2008/01/30 10:54:13 lgarnier Exp $
+// GEANT4 tag $Name:  $
 //
 // 
Index: /trunk/geant4/visualization/OpenGL/include/G4OpenGLStoredQtViewer.hh
===================================================================
--- /trunk/geant4/visualization/OpenGL/include/G4OpenGLStoredQtViewer.hh	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/include/G4OpenGLStoredQtViewer.hh	(revision 704)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLStoredQtViewer.hh,v 1.4 2008/01/15 11:05:08 lgarnier Exp $
+// $Id: G4OpenGLStoredQtViewer.hh,v 1.5 2008/01/30 10:54:13 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
Index: /trunk/geant4/visualization/OpenGL/src/G4OpenGLQtExportDialog.cc
===================================================================
--- /trunk/geant4/visualization/OpenGL/src/G4OpenGLQtExportDialog.cc	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/src/G4OpenGLQtExportDialog.cc	(revision 704)
@@ -25,10 +25,10 @@
 //
 //
-// $Id: G4OpenGLQtExportDialog.cc,v 1.5 2008/01/15 11:05:08 lgarnier Exp $
+// $Id: G4OpenGLQtExportDialog.cc,v 1.6 2008/01/30 10:54:13 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
 // 
 
-#define GEANT4_QT_DEBUG
+//#define GEANT4_QT_DEBUG
 #ifdef G4VIS_BUILD_OPENGLQT_DRIVER
 
Index: /trunk/geant4/visualization/OpenGL/src/G4OpenGLQtViewer.cc
===================================================================
--- /trunk/geant4/visualization/OpenGL/src/G4OpenGLQtViewer.cc	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/src/G4OpenGLQtViewer.cc	(revision 704)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLQtViewer.cc,v 1.9 2008/01/15 11:05:08 lgarnier Exp $
+// $Id: G4OpenGLQtViewer.cc,v 1.10 2008/01/30 10:54:13 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
@@ -36,5 +36,5 @@
 #ifdef G4VIS_BUILD_OPENGLQT_DRIVER
 
-#define GEANT4_QT_DEBUG
+//#define GEANT4_QT_DEBUG
 
 #include "G4OpenGLQtViewer.hh"
@@ -768,5 +768,5 @@
   QAction *fullOff = mFullScreen->addAction("Off");
 #endif
-  createRadioAction(fullOn,fullOff,SLOT(toggleFullScreen(bool)),2);
+  createRadioAction(fullOn,fullOff,SLOT(toggleFullScreen()),2);
 #endif
 
@@ -1234,7 +1234,6 @@
 /**
    SLOT Activate by a click on the full screen menu
-@param check : 1 , 0
-*/
-void G4OpenGLQtViewer::toggleFullScreen(bool check) {
+*/
+void G4OpenGLQtViewer::toggleFullScreen() {
 #if QT_VERSION >= 0x030200
   GLWindow->setWindowState(GLWindow->windowState() ^ Qt::WindowFullScreen);
@@ -1819,5 +1818,8 @@
   holdKeyEvent = true;
 
-  if ((event->key() == Qt::Key_Down) && (event->modifiers() & Qt::ShiftModifier)) // go backward
+  if (event->key() == Qt::Key_Escape) { // escaped from full screen
+    toggleFullScreen();
+    
+  }  else if ((event->key() == Qt::Key_Down) && (event->modifiers() & Qt::ShiftModifier)) // go backward
     {
       G4MouseMoveEvent(0,0,1);
@@ -1879,3 +1881,2 @@
 }
 */
-
Index: /trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQtViewer.cc
===================================================================
--- /trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQtViewer.cc	(revision 703)
+++ /trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQtViewer.cc	(revision 704)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4OpenGLStoredQtViewer.cc,v 1.8 2008/01/15 11:05:08 lgarnier Exp $
+// $Id: G4OpenGLStoredQtViewer.cc,v 1.9 2008/01/30 10:54:13 lgarnier Exp $
 // GEANT4 tag $Name:  $
 //
@@ -34,5 +34,5 @@
 #ifdef G4VIS_BUILD_OPENGLQT_DRIVER
 
-#define GEANT4_QT_DEBUG
+//#define GEANT4_QT_DEBUG
 
 #include "G4OpenGLStoredQtViewer.hh"
@@ -365,3 +365,2 @@
 
 #endif
-
Index: /trunk/geant4/visualization/management/include/G4VisExecutive.icc
===================================================================
--- /trunk/geant4/visualization/management/include/G4VisExecutive.icc	(revision 703)
+++ /trunk/geant4/visualization/management/include/G4VisExecutive.icc	(revision 704)
@@ -97,7 +97,5 @@
   // Graphics Systems not needing external packages or libraries...
   RegisterGraphicsSystem (new G4ASCIITree);
-#ifdef G4VIS_USE_DAWN
-//  RegisterGraphicsSystem (new G4DAWNFILE);
-#endif
+  RegisterGraphicsSystem (new G4DAWNFILE);
   RegisterGraphicsSystem (new G4HepRep);
   RegisterGraphicsSystem (new G4HepRepFile);